#ifndef Unit1H
#define Unit1H

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Graphics.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>

typedef struct tagICONDIRENTRY {
    BYTE  bWidth;
    BYTE  bHeight;
    BYTE  bColorCount;
    BYTE  bReserved;
    WORD  wPlanes;
    WORD  wBitCount;
    DWORD dwBytesInRes;
    DWORD dwImageOffset;
} ICONDIRENTRY;

typedef struct tagICONDIRHEADER {
    WORD          idReserved;
    WORD          idType;
    WORD          idCount;
} ICONDIRHEADER;

typedef struct tagMYICONINFO {
    int nWidth;
    int nHeight;
    BYTE cPlanes;
    BYTE cBitsPixel;
    CONST BYTE *lpbANDbits;
    CONST BYTE *lpbXORbits;
} MYICONINFO;

void __fastcall MesEr(char* st,DWORD val);

class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TPanel *Panel1;
    TGroupBox *GroupBox1;
    TSpeedButton *EraseButton;
    TSpeedButton *PencilButton;
    TSpeedButton *FloodButton;
    TSpeedButton *LineButton;
    TSpeedButton *EllipseButton;
    TSpeedButton *RectButton;
    TSpeedButton *FillEllipseButton;
    TSpeedButton *FillRectButton;
    TPaintBox *Palette;
    TSpeedButton *PointButton;
    TSpeedButton *ScaleButton;
    TMainMenu *MainMenu;
    TMenuItem *N1;
    TMenuItem *N2;
    TMenuItem *N3;
    TMenuItem *N4;
    TMenuItem *N5;
    TMenuItem *N6;
    TMenuItem *N7;
    TMenuItem *N8;
    TMenuItem *N9;
    TMenuItem *N10;
    TMenuItem *N11;
    TMenuItem *N14;
    TMenuItem *N15;
    TMenuItem *N16;
    TMenuItem *N17;
    TMenuItem *N18;
    TMenuItem *N19;
    TMenuItem *N20;
    TMenuItem *N21;
    TMenuItem *N22;
    TMenuItem *N23;
    TMenuItem *N24;
    TMenuItem *N25;
    TMenuItem *N26;
    TOpenDialog *OpenDialog;
    TSaveDialog *SaveDialog;
    TMenuItem *N27;
    TMenuItem *N28;
    TColorDialog *ColorDialog;
    TMenuItem *N12;
    TGroupBox *GroupBox2;
    TImage *SmallIcon;
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TMenuItem *N13;
    TMenuItem *N29;
    TMenuItem *N16x161;
    TMenuItem *N32x321;
    TMenuItem *N30;
    TMenuItem *N31;
    TMenuItem *N32;
    TPanel *Panel2;
    TPaintBox *BigIcon;
    void __fastcall BigIconMouseDown(TObject *Sender,
        TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall BigIconMouseMove(TObject *Sender,
        TShiftState Shift, int X, int Y);
    void __fastcall BigIconMouseUp(TObject *Sender,
        TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall PalettePaint(TObject *Sender);
    void __fastcall PaletteMouseDown(TObject *Sender,
        TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall BigIconPaint(TObject *Sender);
    void __fastcall N2Click(TObject *Sender);
    void __fastcall N3Click(TObject *Sender);
    void __fastcall N4Click(TObject *Sender);
    void __fastcall N6Click(TObject *Sender);
    void __fastcall N15Click(TObject *Sender);
    void __fastcall N16Click(TObject *Sender);
    void __fastcall N17Click(TObject *Sender);
    void __fastcall N18Click(TObject *Sender);
    void __fastcall N19Click(TObject *Sender);
    void __fastcall N20Click(TObject *Sender);
    void __fastcall N21Click(TObject *Sender);
    void __fastcall N22Click(TObject *Sender);
    void __fastcall N27Click(TObject *Sender);
    void __fastcall N28Click(TObject *Sender);
    void __fastcall N9Click(TObject *Sender);
    void __fastcall N8Click(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall N10Click(TObject *Sender);
    void __fastcall PaletteDblClick(TObject *Sender);
    void __fastcall N26Click(TObject *Sender);
    void __fastcall PencilButtonClick(TObject *Sender);
    void __fastcall N24Click(TObject *Sender);
    void __fastcall N16x161Click(TObject *Sender);
    void __fastcall N32Click(TObject *Sender);
private:	// User declarations
    int mX;
    int mY;
    TImage *TmpImage;
    TIcon* mIcon;
    HICON ico;
    DWORD ColorPen;
    DWORD ColorBk;
    DWORD PalIndex;
    BOOL mDown;
    BOOL mEdited;
    BOOL mValidFileName;
    int mScale;
    int mSize;
    void __fastcall DrawShape(int X, int Y);
    void __fastcall DrawStdRect(TCanvas* canv,int X,int Y,int W,int H,COLORREF col);
    bool __fastcall TestSender(TObject * Sender, int X, int Y, int& vX, int& vY);
    void __fastcall DoPoint(TMouseButton Btn, int vX, int vY);
    bool __fastcall AskSaveFile();
    bool __fastcall DoSaveFile(DWORD type);
    bool __fastcall SaveIcon();
    DWORD __fastcall SaveIconFmt(MYICONINFO* mi, char* filename, DWORD type);
public:		// User declarations
    __fastcall TForm1(TComponent* Owner);
public:
};

extern PACKAGE TForm1 *Form1;

#endif

